using System;
using System.Xml;
using System.Collections;

namespace com.markme.mesh.apps
{
    public class CombineOpml
    {
        public CombineOpml()
        {
        }
        
        public static void Main(string[] args)
        {
            int pathCount = args.Length;
            
            if(pathCount < 1)
            {
                Console.WriteLine("Usage : CombineOpml opmlPath1 opmlPath2 opmlPathn ...");
                return;
            }
            
            if(args[0].StartsWith("-h"))
            {
                Console.WriteLine("Usage : CombineOpml opmlPath1 opmlPath2 opmlPathn ...");
                Console.WriteLine("The opmlPath can be a relative or absolute file path, or an absolute URL.");
                Console.WriteLine("Created by Mike Chambers : http://mesh.typepad.com");
                return;
            }
            
            Hashtable hash = new Hashtable();
            
            XmlDocument doc;
            XmlNodeList nodeList;
            string xmlUrl;
            
            for(int i = 0; i < pathCount; i++)
            {
                doc = new XmlDocument();
                
                try
                {
                    doc.Load(args[i]);
                }
                catch
                {
                    continue;
                }
                
                nodeList = doc.SelectNodes("/opml/body/outline");
                
                foreach(XmlNode n in nodeList)
                {
                    try
                    {
                        xmlUrl = n.Attributes.GetNamedItem("xmlUrl").Value;
                    }
                    catch
                    {
                        continue;
                    }
                    
                    if(!hash.ContainsKey(xmlUrl))
                    {
                        hash.Add(xmlUrl, n);
                    }
                }
                
            }
            
            Console.WriteLine("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>");
            Console.WriteLine("<opml version=\"1.1\">");
            Console.WriteLine("<head>\n");
            Console.WriteLine("\t<title>Combined OPML Subscriptions</title>");
            Console.WriteLine("</head>");
            Console.WriteLine("<!--");
            Console.WriteLine("\tGenerated by CombineOpml.");
            Console.WriteLine("\tCreated by Mike Chambers");
            Console.WriteLine("\thttp://mesh.typepad.com");
            Console.WriteLine("-->");
            Console.WriteLine("<body>");
            
            ICollection values = hash.Values;
            
            foreach(XmlNode n in values)
            {
                Console.WriteLine("\t" + n.OuterXml);
            }
            
            Console.WriteLine("</body>");
            Console.WriteLine("</opml>");

            
        }
    }
}